package techreborn.client.container;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.ICrafting;
import reborncore.client.gui.BaseSlot;
import net.minecraft.inventory.SlotFurnaceFuel;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import reborncore.client.gui.SlotCharge;
import reborncore.common.container.RebornContainer;
import techreborn.tiles.generator.TileGenerator;

public class ContainerGenerator extends RebornContainer
{

	public int burnTime = 0;
	public int totalBurnTime = 0;
	public int energy;
	public int tickTime;
	EntityPlayer player;
	TileGenerator tile;

	public ContainerGenerator(TileGenerator tile, EntityPlayer player)
	{
		super();
		this.tile = tile;
		this.player = player;

		// fuel
		this.func_75146_a(new SlotFurnaceFuel(tile.inventory, 0, 80, 53));
		// charge
		this.func_75146_a(new SlotCharge(tile.inventory, 1, 80, 17));

		int i;

		for (i = 0; i < 3; ++i)
		{
			for (int j = 0; j < 9; ++j)
			{
				this.func_75146_a(new BaseSlot(player.field_71071_by, j + i * 9 + 9, 8 + j * 18, 84 + i * 18));
			}
		}

		for (i = 0; i < 9; ++i)
		{
			this.func_75146_a(new BaseSlot(player.field_71071_by, i, 8 + i * 18, 142));
		}
	}

	@Override
	public boolean func_75145_c(EntityPlayer player)
	{
		return true;
	}

	@Override
	public void func_75142_b()
	{
		super.func_75142_b();
		for (int i = 0; i < this.field_75149_d.size(); i++)
		{
			ICrafting icrafting = this.field_75149_d.get(i);
			if (this.burnTime != tile.burnTime)
			{
				icrafting.func_71112_a(this, 0, tile.burnTime);
			}
			if (this.totalBurnTime != tile.totalBurnTime)
			{
				icrafting.func_71112_a(this, 1, tile.totalBurnTime);
			}
			if (this.energy != (int) tile.getEnergy())
			{
				icrafting.func_71112_a(this, 2, (int) tile.getEnergy());
			}
		}
	}

	@Override
	public void func_75132_a(ICrafting crafting)
	{
		super.func_75132_a(crafting);
		crafting.func_71112_a(this, 0, tile.burnTime);
		crafting.func_71112_a(this, 1, tile.totalBurnTime);
		crafting.func_71112_a(this, 2, (int) tile.getEnergy());
	}

	@SideOnly(Side.CLIENT)
	@Override
	public void func_75137_b(int id, int value)
	{
		if (id == 0)
		{
			this.burnTime = value;
		} else if (id == 1)
		{
			this.totalBurnTime = value;
		} else if (id == 2)
		{
			this.energy = value;
		}
		this.tile.setEnergy(energy);
	}

	public int getScaledBurnTime(int i)
	{
		return (int) (((float) burnTime / (float) totalBurnTime) * i);
	}

}
