package techreborn.items;

import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.world.World;
import techreborn.Core;
import techreborn.client.GuiHandler;
import techreborn.client.TechRebornCreativeTab;
import techreborn.init.ModItems;
import techreborn.lib.ModInfo;

import java.security.InvalidParameterException;
import java.util.List;

public class ItemParts extends ItemTextureBase
{
	public static final String[] types = new String[] { "energyFlowCircuit", "dataControlCircuit", "dataStorageCircuit",
			"dataOrb", "diamondGrindingHead", "diamondSawBlade", "wolframiumGrindingHead", "heliumCoolantSimple",
			"heliumCoolantTriple", "heliumCoolantSix", "NaKCoolantSimple", "NaKCoolantTriple", "NaKCoolantSix",
			"cupronickelHeatingCoil", "nichromeHeatingCoil", "kanthalHeatingCoil", "lazuriteChunk", "superConductor",
			"thoriumCell", "doubleThoriumCell", "quadThoriumCell", "plutoniumCell", "doublePlutoniumCell",
			"quadPlutoniumCell", "computerMonitor", "machineParts", "neutronReflector", "iridiumNeutronReflector",
			"thickNeutronReflector", "electronicCircuit", "advancedCircuit", "rubberSap", "rubber", "scrap",
			"carbonmesh", "carbonfiber", "coolantSimple", "coolantTriple", "coolantSix" };

	public ItemParts()
	{
		func_77637_a(TechRebornCreativeTab.instance);
		func_77627_a(true);
		func_77655_b("techreborn.part");
	}

	public static ItemStack getPartByName(String name, int count)
	{
		for (int i = 0; i < types.length; i++)
		{
			if (types[i].equalsIgnoreCase(name))
			{
				return new ItemStack(ModItems.parts, count, i);
			}
		}
		throw new InvalidParameterException("The part " + name + " could not be found.");
	}

	public static ItemStack getPartByName(String name)
	{
		return getPartByName(name, 1);
	}

	@Override
	// gets Unlocalized Name depending on meta data
	public String func_77667_c(ItemStack itemStack)
	{
		int meta = itemStack.func_77952_i();
		if (meta < 0 || meta >= types.length)
		{
			meta = 0;
		}

		return super.func_77658_a() + "." + types[meta];
	}

	// Adds Dusts SubItems To Creative Tab
	public void func_150895_a(Item item, CreativeTabs creativeTabs, List list)
	{
		for (int meta = 0; meta < types.length; ++meta)
		{
			list.add(new ItemStack(item, 1, meta));
		}
	}

	public ItemStack onItemRightClick(ItemStack itemStack, World world, EntityPlayer player)
	{
		switch (itemStack.func_77952_i())
		{
			case 37: // Destructo pack
				player.openGui(Core.INSTANCE, GuiHandler.destructoPackID, world, (int) player.field_70165_t, (int) player.field_70163_u,
						(int) player.field_70163_u);
				break;
		}
		return itemStack;
	}

	@Override public String getTextureName(int damage)
	{
		return ModInfo.MOD_ID + ":items/part/" + types[damage];
	}

	@Override public int getMaxMeta()
	{
		return types.length;
	}
}
