package techreborn.items.tools;

import java.util.List;

import me.modmuss50.jsonDestroyer.api.ITexturedItem;
import net.minecraft.block.state.IBlockState;
import net.minecraft.client.renderer.block.model.ModelResourceLocation;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.enchantment.Enchantment;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Items;
import net.minecraft.item.Item;
import net.minecraft.item.ItemPickaxe;
import net.minecraft.item.ItemStack;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import reborncore.RebornCore;
import reborncore.api.power.IEnergyItemInfo;
import reborncore.common.powerSystem.PoweredItem;
import reborncore.common.util.Color;
import techreborn.client.TechRebornCreativeTab;
import techreborn.config.ConfigTechReborn;
import techreborn.lib.ModInfo;

import net.minecraft.item.Item.ToolMaterial;
import net.minecraft.item.Item.ToolMaterial;
public class ItemRockCutter extends ItemPickaxe implements IEnergyItemInfo, ITexturedItem
{

	public static final int maxCharge = ConfigTechReborn.RockCutterCharge;
	public static final int tier = ConfigTechReborn.RockCutterTier;
	public int cost = 500;

	public ItemRockCutter()
	{
		super(ToolMaterial.DIAMOND);
		func_77655_b("techreborn.rockcutter");
		func_77637_a(TechRebornCreativeTab.instance);
		func_77625_d(1);
		field_77864_a = 16F;
		RebornCore.jsonDestroyer.registerObject(this);
	}

	@Override
	@SideOnly(Side.CLIENT)
	public boolean func_77636_d(ItemStack ist)
	{
		return true;
	}

	@Override
	public void func_77624_a(ItemStack iS, EntityPlayer par2EntityPlayer, List par3List, boolean par4)
	{
		if (!iS.func_77948_v())
		{
			par3List.add(Color.WHITE + "Silk Touch I");
		}
	}

	@Override
	public boolean func_150897_b(IBlockState state)
	{
		if (Items.field_151046_w.func_150897_b(state))
		{
//			 if (PoweredItem.canUseEnergy(cost, stack)) {
//			 PoweredItem.useEnergy(cost, stack);
//			 return true;
//			 }
		}
		return false;
	}

	 @Override
	 public int getHarvestLevel(ItemStack stack, String toolClass) {
	 if (!stack.func_77948_v()) {
	 stack.func_77966_a(Enchantment.func_185262_c(33), 1);
	 }
	 return super.getHarvestLevel(stack, toolClass);
	 }

	 @Override
	 public float func_150893_a(ItemStack stack, IBlockState block) {
	 if (!stack.func_77948_v()) {
	 stack.func_77966_a(Enchantment.func_185262_c(33), 1);
	 }
	 return super.func_150893_a(stack, block);
	 }

	@Override
	public boolean isRepairable()
	{
		return false;
	}

	// public void onCreated(ItemStack par1ItemStack, World par2World,
	// EntityPlayer par3EntityPlayer) {
	// par1ItemStack.addEnchantment(Enchantment.silkTouch, 1);
	// }

	@Override
	public double getMaxPower(ItemStack stack)
	{
		return maxCharge;
	}

	@Override
	public boolean canAcceptEnergy(ItemStack stack)
	{
		return true;
	}

	@Override
	public boolean canProvideEnergy(ItemStack stack)
	{
		return false;
	}

	@Override
	public double getMaxTransfer(ItemStack stack)
	{
		return 200;
	}

	@Override
	public int getStackTier(ItemStack stack)
	{
		return 2;
	}

	@SuppressWarnings({ "rawtypes", "unchecked" })
	@SideOnly(Side.CLIENT)
	public void func_150895_a(Item item, CreativeTabs par2CreativeTabs, List itemList)
	{
		ItemStack itemStack = new ItemStack(this, 1);
		itemList.add(itemStack);

		ItemStack charged = new ItemStack(this, 1);
		PoweredItem.setEnergy(getMaxPower(charged), charged);
		itemList.add(charged);
	}

	@Override
	public double getDurabilityForDisplay(ItemStack stack)
	{
		double charge = (PoweredItem.getEnergy(stack) / getMaxPower(stack));
		return 1 - charge;

	}

	@Override
	public boolean showDurabilityBar(ItemStack stack)
	{
		return true;
	}

	@Override
	public String getTextureName(int damage)
	{
		return "techreborn:items/tool/rockcutter";
	}

	@Override
	public int getMaxMeta()
	{
		return 1;
	}

	@Override
	@SideOnly(Side.CLIENT)
	public ModelResourceLocation getModel(ItemStack stack, EntityPlayer player, int useRemaining)
	{
		return new ModelResourceLocation(ModInfo.MOD_ID + ":" + func_77667_c(stack).substring(5), "inventory");
	}

}
