package techreborn.tiles.generator;

import reborncore.common.IWrenchable;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntityFurnace;
import net.minecraft.util.EnumFacing;
import reborncore.api.power.EnumPowerTier;
import reborncore.api.tile.IInventoryProvider;
import reborncore.common.blocks.BlockMachineBase;
import reborncore.common.powerSystem.TilePowerAcceptor;
import reborncore.common.util.Inventory;
import techreborn.init.ModBlocks;

public class TileGenerator extends TilePowerAcceptor implements IWrenchable,IInventoryProvider
{
	public static int outputAmount = 10; // This is in line with BC engines rf,
	public Inventory inventory = new Inventory(2, "TileGenerator", 64, this);
	public int fuelSlot = 0;
	public int burnTime;
	public int totalBurnTime = 0;
											// sould properly use the conversion
											// ratio here.
	public boolean isBurning;
	public boolean lastTickBurning;
	ItemStack burnItem;

	public TileGenerator()
	{
		super(1);
	}

	public static int getItemBurnTime(ItemStack stack)
	{
		return TileEntityFurnace.func_145952_a(stack);
	}

	@Override
	public void updateEntity()
	{
		super.updateEntity();
		if (field_145850_b.field_72995_K)
		{
			return;
		}
		if (getEnergy() < getMaxPower())
		{
			if (burnTime > 0)
			{
				burnTime--;
				addEnergy(outputAmount);
				isBurning = true;
			}
		} else
		{
			isBurning = false;
		}

		if (burnTime == 0)
		{
			updateState();
			burnTime = totalBurnTime = getItemBurnTime(func_70301_a(fuelSlot));
			if (burnTime > 0)
			{
				updateState();
				burnItem = func_70301_a(fuelSlot);
				if (func_70301_a(fuelSlot).field_77994_a == 1)
				{
					func_70299_a(fuelSlot, null);
				} else
				{
					func_70298_a(fuelSlot, 1);
				}
			}
		}

		lastTickBurning = isBurning;
	}

	public void updateState()
	{
		IBlockState BlockStateContainer = field_145850_b.func_180495_p(field_174879_c);
		if (BlockStateContainer.func_177230_c() instanceof BlockMachineBase)
		{
			BlockMachineBase blockMachineBase = (BlockMachineBase) BlockStateContainer.func_177230_c();
			if (BlockStateContainer.func_177229_b(BlockMachineBase.ACTIVE) != burnTime > 0)
				blockMachineBase.setActive(burnTime > 0, field_145850_b, field_174879_c);
		}
	}

	@Override
	public boolean wrenchCanSetFacing(EntityPlayer entityPlayer, EnumFacing side)
	{
		return false;
	}

	@Override
	public EnumFacing getFacing()
	{
		return getFacingEnum();
	}

	@Override
	public boolean wrenchCanRemove(EntityPlayer entityPlayer)
	{
		return entityPlayer.func_70093_af();
	}

	@Override
	public float getWrenchDropRate()
	{
		return 1.0F;
	}

	@Override
	public double getMaxPower()
	{
		return 100;
	}

	@Override
	public boolean canAcceptEnergy(EnumFacing direction)
	{
		return false;
	}

	@Override
	public boolean canProvideEnergy(EnumFacing direction)
	{
		return true;
	}

	@Override
	public double getMaxOutput()
	{
		return 64;
	}

	@Override
	public double getMaxInput()
	{
		return 0;
	}

	@Override
	public EnumPowerTier getTier()
	{
		return EnumPowerTier.LOW;
	}

	@Override
	public ItemStack getWrenchDrop(EntityPlayer p0)
	{
		return new ItemStack(ModBlocks.Generator);
	}

	@Override
	public Inventory getInventory() {
		return inventory;
	}
}
