package techreborn.tiles.teir1;

import reborncore.common.IWrenchable;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.ISidedInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumFacing;
import reborncore.api.power.EnumPowerTier;
import reborncore.api.tile.IInventoryProvider;
import reborncore.common.blocks.BlockMachineBase;
import reborncore.common.powerSystem.TilePowerAcceptor;
import reborncore.common.util.Inventory;
import techreborn.init.ModBlocks;
import techreborn.items.ItemParts;

public class TileRecycler extends TilePowerAcceptor implements IWrenchable,IInventoryProvider, ISidedInventory
{

	public Inventory inventory = new Inventory(6, "TileRecycler", 64, this);
	public int capacity = 1000;
	public int cost = 20;
	public int progress;
	public int time = 200;
	public int chance = 4;
	public int random;
	public int input1 = 0;
	public int output = 1;

	public TileRecycler()
	{
		super(1);
	}

	public int gaugeProgressScaled(int scale)
	{
		return (progress * scale) / time;
	}

	@Override
	public void updateEntity()
	{
		if(field_145850_b.field_72995_K){
			return;
		}
		boolean burning = isBurning();
		boolean updateInventory = false;
		if (getEnergy() <= cost && canRecycle())
		{
			if (getEnergy() > cost)
			{
				updateInventory = true;
			}
		}
		if (isBurning() && canRecycle())
		{
			updateState();

			progress++;
			if (progress >= time)
			{
				progress = 0;
				recycleItems();
				updateInventory = true;
			}
		} else
		{
			progress = 0;
			updateState();
		}
		if (burning != isBurning())
		{
			updateInventory = true;
		}
		if (updateInventory)
		{
			func_70296_d();
		}
	}

	public void recycleItems()
	{
		if (this.canRecycle())
		{
			ItemStack itemstack = ItemParts.getPartByName("scrap");
			int randomchance = field_145850_b.field_73012_v.nextInt(chance);

			if (func_70301_a(output) == null)
			{
				useEnergy(cost);
				if (randomchance == 1)
				{
					func_70299_a(output, itemstack.func_77946_l());
				}
			} else if (func_70301_a(output).func_77969_a(itemstack))
			{
				useEnergy(cost);
				if (randomchance == 1)
				{
					func_70301_a(output).field_77994_a += itemstack.field_77994_a;
				}
			}
			if (func_70301_a(input1).field_77994_a > 1)
			{
				useEnergy(cost);
				this.func_70298_a(input1, 1);
			} else
			{
				useEnergy(cost);
				func_70299_a(input1, null);
			}
		}
	}

	public boolean canRecycle()
	{
		return func_70301_a(input1) != null && hasSlotGotSpace(output);
	}

	public boolean hasSlotGotSpace(int slot)
	{
		if (func_70301_a(slot) == null)
		{
			return true;
		} else if (func_70301_a(slot).field_77994_a < func_70301_a(slot).func_77976_d())
		{
			return true;
		}
		return true;
	}

	public boolean isBurning()
	{
		return getEnergy() > cost;
	}

	public void updateState()
	{
		IBlockState BlockStateContainer = field_145850_b.func_180495_p(field_174879_c);
		if (BlockStateContainer.func_177230_c() instanceof BlockMachineBase)
		{
			BlockMachineBase blockMachineBase = (BlockMachineBase) BlockStateContainer.func_177230_c();
			if (BlockStateContainer.func_177229_b(BlockMachineBase.ACTIVE) != progress > 0)
				blockMachineBase.setActive(progress > 0, field_145850_b, field_174879_c);
		}
	}

	@Override
	public boolean wrenchCanSetFacing(EntityPlayer entityPlayer, EnumFacing side)
	{
		return false;
	}

	@Override
	public EnumFacing getFacing()
	{
		return getFacingEnum();
	}

	@Override
	public boolean wrenchCanRemove(EntityPlayer entityPlayer)
	{
		return entityPlayer.func_70093_af();
	}

	@Override
	public float getWrenchDropRate()
	{
		return 1.0F;
	}

	@Override
	public ItemStack getWrenchDrop(EntityPlayer entityPlayer)
	{
		return new ItemStack(ModBlocks.recycler, 1);
	}

	public boolean isComplete()
	{
		return false;
	}

	// ISidedInventory
	@Override
	public int[] func_180463_a(EnumFacing side)
	{
		return side == EnumFacing.DOWN ? new int[] { output } : new int[] { input1 };
	}

	@Override
	public boolean func_180462_a(int slotIndex, ItemStack itemStack, EnumFacing side)
	{
		if (slotIndex == output)
			return false;
		return func_94041_b(slotIndex, itemStack);
	}

	@Override
	public boolean func_180461_b(int slotIndex, ItemStack itemStack, EnumFacing side)
	{
		return slotIndex == output;
	}

	@Override
	public double getMaxPower()
	{
		return capacity;
	}

	@Override
	public boolean canAcceptEnergy(EnumFacing direction)
	{
		return true;
	}

	@Override
	public boolean canProvideEnergy(EnumFacing direction)
	{
		return false;
	}

	@Override
	public double getMaxOutput()
	{
		return 0;
	}

	@Override
	public double getMaxInput()
	{
		return 32;
	}

	@Override
	public EnumPowerTier getTier()
	{
		return EnumPowerTier.MEDIUM;
	}

	@Override
	public Inventory getInventory() {
		return inventory;
	}
}
